'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var reduxObservable = require('redux-observable');

function combine(options) {
    return function (allActions, allSelectors) {
        const packs = Array.isArray(options) ? options : Object.values(options);
        return reduxObservable.combineEpics(...packs
            .map((pack) => pack.epics)
            .filter(Boolean)
            .map((epic) => epic(allActions, allSelectors)));
    };
}
function createEpicPackerMiddleware() {
    return {
        create: (pre, post) => ({
            ...post,
            epics: combine(pre),
        }),
        merge: (pre, post) => ({
            ...post,
            epics: combine(pre),
        }),
        extract: (pre, post) => ({
            ...post,
            epics: pre.epics(post.actions, post.selectors),
        }),
        mergeExtracted: (pre, post) => ({
            ...post,
            epics: reduxObservable.combineEpics(...pre.map((extractedPack) => extractedPack.epics)),
        }),
    };
}

exports.createEpicPackerMiddleware = createEpicPackerMiddleware;
